package net.mcreator.target.item;

import net.mcreator.target.entity.ClaymoreEntity;
import net.mcreator.target.init.TargetModEntities;
import net.minecraft.network.chat.Component;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.TamableAnimal;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.level.Level;

import java.util.List;

public class ClaymoreMineItem extends Item {
    public ClaymoreMineItem() {
        super(new Item.Properties().stacksTo(64).rarity(Rarity.COMMON));
    }

    @Override
    public void appendHoverText(ItemStack itemstack, Level world, List<Component> list, TooltipFlag flag) {
        super.appendHoverText(itemstack, world, list, flag);
    }

    @Override
    public InteractionResultHolder<ItemStack> use(Level world, Player player, InteractionHand hand) {
        ItemStack stack = player.getItemInHand(hand);

        if (world instanceof ServerLevel serverLevel) {
            TamableAnimal entityToSpawn = new ClaymoreEntity(TargetModEntities.CLAYMORE.get(), serverLevel);
            entityToSpawn.moveTo(player.getX(), player.getY() + 1.1, player.getZ(), player.getYRot(), player.getXRot());
            entityToSpawn.setYBodyRot(player.getYRot());
            entityToSpawn.setYHeadRot(player.getYRot());
            entityToSpawn.setDeltaMovement((0.5 * player.getLookAngle().x), (0.5 * player.getLookAngle().y), (0.5 * player.getLookAngle().z));
            entityToSpawn.finalizeSpawn(serverLevel, serverLevel.getCurrentDifficultyAt(entityToSpawn.blockPosition()), MobSpawnType.MOB_SUMMONED, null, null);
            entityToSpawn.tame(player);
            serverLevel.addFreshEntity(entityToSpawn);
        }

        player.getCooldowns().addCooldown(this, 20);
        stack.shrink(1);

        return InteractionResultHolder.consume(stack);
    }
}
